<?php
/***** Every chatpacket from funcom triggers this function
****** Idea: funcom engine i guess .. ;)
*****/
function callback($type, $args)
{
	global $AOC,
	       $myguild,
	       $myname,
	       $channels,
	       $BuddyList,
	       $SendReply;

	/***** Got a paket.. 
	****** do a little output (in debugmode)
	*****/
	if ($type!=30&&$type!=65&&$type!=57&&$type!=100) { #100 is PONG!
	        say("CB[$type] :: ".verbose_output($type, $args),1);
	} else {
		$SendReply["type"]=$type;
	}
	/*****
	****** Public Chat Channel management: if the packet from the chat server is the info about a Public Chat Channel
	*****/
	if ($type==60)
	{
		#Thanks to IGN-Bot.. http://monkerud.com
		// breakdown the Group ID
		$b = unpack("C*", $args[0]);
		#if the first byte is a 3, then this group is my guild
		if ($b[1]==3)
		{
			#remember my guild name
			$myguild = $args[1];
			#remember my guild number (maybe for later use when funcom releases a guildroster for conan..
			$myguild_number = $b[2]*256*256*256 + $b[3]*256*256 + $b[4]*256 + $b[5];
		}
		// remember chat channels
		// $args[0] is the Group ID
		// $args[1] is the Group Name
		// $args[2] are settings about the group, like muted/unmuted
		// if $args[2] is a number larger/equal than 256*256, then it means the channel is unmuted
		$channels[$args[0]]=$args[1];
	}

	/*****
        ****** clientname triggerd
        *****/
	if ($type==20) {
		$senderid        =$args[0]; #id
		$sender          =$args[2]; #name
		execute_plugin("lookup",$args,$senderid,$sender);
		#say("Got clientname",1);
	}
	/*****
        ****** lookup triggerd
        *****/
	if ($type==21) {
		$senderid        =$args[0]; #id
		$sender          =$args[1]; #name
		say("Got namelookup: $senderid :: $sender",1);
	}
	/***** 
        ****** tell (ignore standard AFK - message..)
        *****/
	if ($type==30 && $message!="The user is currently AFK.") {
		$SendReply["name"]=$AOC->id[$args[0]];
		$sender           =$AOC->id[$args[0]];
		$message          =$args[1];
		$blob             =$args[2];
		$messageitems = multilinkstoarray($message);
		execute_plugin("tell",$args,$message,$sender);
		#say("[$chat_channel_name]".$AOC->id[$args[0]].": ".$args[1],1);
	}
	/*****
	****** message on a public chat channel
	*****/
	if ($type==65 && $AOC->id[$args[1]]!=$myname) {
		$SendReply["name"]=$AOC->gid[$args[0]];
		$chat_channel_name=$AOC->gid[$args[0]];
		$sender           =$AOC->id[$args[1]];
		$message          =$args[2];
		$blob             =$args[3];
		if ($chat_channel_name==$myguild  ) {
		        #Guild handling (and it was not myself that sent it)
			execute_plugin("guild",$args,$message,$sender);
		} else {
			#Public channel (and it was not myself that sent it)
			#You can get the channelname: $AOC->lookup_group($args[0]);
			execute_plugin("public",$args,$message,$sender);
		}
		#say("[$chat_channel_name]".$AOC->id[$args[1]].": ".$args[2],1);
	}
	/*****
        ****** message on a private channel 
        *****/
	if ($type==57 && $AOC->id[$args[1]]!=$myname)
	{
		$SendReply["name"]=$AOC->id[$args[0]];
		$chat_channel_name=$AOC->id[$args[0]];
		$sender           =$AOC->id[$args[1]];
		$message          =$args[2];
		$blob             =$args[3];
		say("Private channel message! Ignored :D",1);
	}
	/******
	******* invite to a private chat channel 
	******/
	if ($type==50) {
		#AOC->join_privgroup($args[0]);
		say("Private channel invite! Ignored :D",1);
	}
	/******
	******* Buddy on my buddylist comes online or offline
	******/
	#aoc: args-array = char-id , online status , class ,  playfield? , level?
	if ($type==40)
	{
		$BuddyList[$args[0]]["laststatus"]= $BuddyList[$args[0]]["status"];
		$BuddyList[$args[0]]["status"]    = $args[1];
		$BuddyList[$args[0]]["playfield"] = 0 + $args[3];
		$BuddyList[$args[0]]["level"]     = 0 + $args[2];
		$BuddyList[$args[0]]["class"]     = 0 + $args[4];
		$BuddyList[$args[0]]["name"]      = $AOC->id[$args[0]];
		execute_plugin("buddy",$BuddyList[$args[0]],$args[0],$BuddyList[$args[0]]["name"]);
	} 
	/******
	******* if a buddy is removed from my buddylist
	******/
	if ($type==41 && $args[0])
	{
		// $args[0] will be a number, here is the name $AOC->id[$args[0]];
		unset($BuddyList[$args[0]]);
	}
}
/****** Handles the execution of your plugins
******* Idea: Angelsbot (frozen anarchy online project)
******/
function execute_plugin($type,$args,$message,$sender) {
	global $channels,$AOC_loaded;
	#no handling of offline-events
	if (!$AOC_loaded) return;
	#clean message: lowercase, no trashbytes (colorcodes), kick extra spaces 
	$lowecase_message = strtolower(stripcolors($message));
	$lowecase_message = ereg_replace('[[:space:]]+', ' ', $lowecase_message);
	#define some variables the plugins may also use
	$plugindirname="./plugins/$type/";
	$pluginargs   =$args;
	$pluginmessage=$message;
	$pluginwords  =split(' ',"trash ".$lowecase_message);
	if (isset($args[0]) && isset($channels[$args[0]]) && $channels[$args[0]])
		$pluginchannel=$channels[$args[0]];
	else
		$pluginchannel="";
	if (!is_dir($plugindirname)) {
		say("No plugin dir $plugindirname,current is ".getcwd());
	} else {
		$plugindir=@opendir($plugindirname);	
		set_error_handler('handle_plugin_error');
		while (false !== ($pluginname = readdir($plugindir))) {
			if ($pluginname!="."&&$pluginname!="..") {
				$currentplugin = $plugindirname.$pluginname;
				$pluginname = $plugindirname.$pluginname."/index.php";
				if (!file_exists($pluginname)) {
					say("Plugin $pluginname without index found");
				} else {
					include($pluginname);
				}
			}
		}
		restore_error_handler();
		closedir($plugindir);
	}
}
/******
******* handles the errors of your plugins ;)
******/
function handle_plugin_error($errno, $errstr, $errfile, $errline) {
	if ($errno==2) {
		say("PHP ERROR $errno :: $errfile :: line $errline ::\n:: $errstr");
	}
	return true;
}
?>
